/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink_$type } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { LRUCache$2 } from "./LRUCache$2";
import { Base, runOn, Array_$type, Number_$type, typeCast, fromEnum, typeGetValue, String_$type, Boolean_$type, markType } from "./type";
import { IDataSourcePage_$type } from "./IDataSourcePage";
import { Dictionary$2 } from "./Dictionary$2";
import { SectionMap } from "./SectionMap";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { SectionData } from "./SectionData";
import { List$1 } from "./List$1";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { TransactionState } from "./TransactionState";
import { TransactionType } from "./TransactionType";
import { DataSourceBatchStartedEventArgs } from "./DataSourceBatchStartedEventArgs";
import { DataSourceBatchCompletedEventArgs } from "./DataSourceBatchCompletedEventArgs";
import { truncate, intDivide } from "./number";
/**
 * @hidden
 */
export let VirtualDataSource = /*@__PURE__*/ (() => {
    class VirtualDataSource extends BaseDataSource {
        constructor() {
            super();
            this.dm = false;
            this.d9 = 0;
            this.dg = null;
            this.c7 = null;
            this.c6 = null;
            this.d8 = 50;
            this.d7 = 200;
            this.actualPageSizePopulated = false;
            this.dt = 50;
            this.dk = false;
            this.db = null;
            this.c2 = null;
            this.c3 = null;
            this.dj = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
            this.dr = new Dictionary$2(Base.$, Array_$type, 0);
            this.ds = new Dictionary$2(Number_$type, Number_$type, 0);
            this.dl = false;
            this.c0 = null;
            this.c4 = null;
            this.di = new SectionMap();
            this.c1 = null;
            this.d1 = -1;
            this.du = -1;
            this.d3 = -1;
            this.dw = -1;
            this.d4 = -1;
            this.dx = -1;
            this.d2 = -1;
            this.dv = -1;
            this.d6 = -1;
            this.d5 = -1;
            this.dz = -1;
            this.dy = -1;
            this.d0 = -1;
            this.dq = new Dictionary$2(String_$type, Boolean_$type, 0);
            this._concurrencyTag = null;
            this.batchStarted = null;
            this.batchCompleted = null;
            this.dg = new PagePredictionEngine();
            this.dg.e = this;
            this.dg.ag = this.actualPageSize;
            this.dg.f = this.di;
            this.executionContext = new DataSourceExecutionContext();
            this.dg.b = this.executionContext;
            this.isReadOnly = true;
        }
        get_isSectionCollapsable() {
            if (!this.isSectionContentVisible) {
                return true;
            }
            return super.get_isSectionCollapsable();
        }
        set_isSectionCollapsable(a) {
            super.set_isSectionCollapsable(a);
        }
        get_isSectionExpandedDefault() {
            if (!this.isSectionContentVisible) {
                return false;
            }
            if (this.isSectionCollapsable) {
                return super.get_isSectionExpandedDefault();
            }
            return true;
        }
        set_isSectionExpandedDefault(a) {
            super.set_isSectionExpandedDefault(a);
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.c7;
        }
        set dataProvider(a) {
            let b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.onPropertyUpdated("DataProvider", b, this.c7);
            }
        }
        get actualDataProvider() {
            if (this.c6 == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.c6;
        }
        set actualDataProvider(a) {
            let b = this.c6;
            this.c6 = a;
            if (b != this.c6) {
                this.onPropertyUpdated("ActualDataProvider", b, this.c6);
            }
        }
        get pageSizeRequested() {
            return this.d8;
        }
        set pageSizeRequested(a) {
            let b = this.d8;
            this.d8 = a;
            if (b != this.d8) {
                this.onPropertyUpdated("PageSizeRequested", b, this.d8);
            }
        }
        resetCache() {
            if (this.dc != null) {
                this.dc.resetCache();
            }
            this.resetCacheOverride();
        }
        resetCacheOverride() {
            this.dj.i();
        }
        get maxCachedPages() {
            return this.d7;
        }
        set maxCachedPages(a) {
            let b = this.d7;
            this.d7 = a;
            if (b != this.d7) {
                this.onPropertyUpdated("MaxCachedPages", b, this.d7);
            }
        }
        get actualPageSize() {
            return this.dt;
        }
        set actualPageSize(a) {
            let b = this.dt;
            this.dt = a;
            if (b != this.dt) {
                this.onPropertyUpdated("ActualPageSize", b, this.dt);
            }
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.dk) {
                this.dk = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.dk = false;
                return a;
            }
            return false;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.dk) {
                this.dk = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.dk = false;
                return a;
            }
            return false;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.dk) {
                this.dk = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.dk = false;
                return a;
            }
            return false;
        }
        get dc() {
            return this.db;
        }
        set dc(a) {
            this.db = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            if (this.dc == null) {
                return null;
            }
            return this.dc.resolveDataProvider();
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    this.queueAutoRefresh();
                    break;
                case "ExecutionContext":
                    this.dg.b = this.executionContext;
                    break;
                case "ActualDataProvider":
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    this.actualDataProvider.pageLoaded = runOn(this, this.eu);
                    this.actualDataProvider.batchCompleted = runOn(this, this.et);
                    this.queueAutoRefresh();
                    break;
                case "PageSizeRequested":
                    this.actualPageSize = this.pageSizeRequested;
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    }
                    this.queueAutoRefresh();
                    break;
                case "ActualPageSize":
                    this.dg.ag = this.actualPageSize;
                    this.queueAutoRefresh();
                    break;
                case "FirstVisibleIndexRequested":
                    this.dg.aa = this.firstVisibleIndexRequested;
                    break;
                case "LastVisibleIndexRequested":
                    this.dg.ae = this.lastVisibleIndexRequested;
                    break;
                case "ActualCount":
                    if (this.actualDataProvider != null && !this.di.q) {
                        this.dg.ab = this.actualDataProvider.actualCount;
                    }
                    else {
                        this.dg.ab = this.actualCount;
                    }
                    this.queueAutoRefresh();
                    break;
                case "MaxCachedPages":
                    this.dj.h = this.maxCachedPages;
                    break;
            }
        }
        ed(a) {
            if (this.aq && this.di.q) {
                let b = this.dh(a);
                if (b == null) {
                    b = this.di.d();
                }
                return a - b.t;
            }
            return a;
        }
        eu(a, b, c) {
            let d = this.executionContext;
            if (d != null) {
                d.execute(() => this.e0(a, b, c));
            }
            else {
                this.e0(a, b, c);
            }
        }
        e0(a, b, c) {
            if (a == null) {
                b = this.resolveFullCount(b);
                if (this.actualCount != b) {
                    this.actualCount = b;
                }
                return;
            }
            if (c != this.actualPageSize && !this.actualPageSizePopulated) {
                this.actualPageSize = c;
            }
            this.actualPageSizePopulated = true;
            let d = a.pageIndex();
            this.ev(d);
            this.dj.item(d, a);
            let e = a.schema();
            if (e != null) {
                this.actualSchema = e;
            }
            let f = a.getSummaryInformation();
            if (this.summaryDescriptions.k.count > 0 && this.c4 == null && f != null) {
                this.c4 = f;
                for (let g = 0; g < this.c4.length; g++) {
                    this.c4[g].summaryIndex = this.eb(this.c4[g]);
                }
                let h = SectionData.r(this.c4);
                this.d9 = h.count;
            }
            let i = a.getGroupInformation();
            if (this.groupDescriptions.k.count > 0 && this.c0 == null && i != null) {
                this.c0 = i;
                this.ez();
                this.dm = false;
            }
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            this.ey(a);
        }
        eb(a) {
            for (let b = 0; b < this.summaryDescriptions.k.count; b++) {
                let c = this.summaryDescriptions.k.item(b);
                if (c.propertyName == a.propertyName && c.operand == a.operand) {
                    return b;
                }
            }
            return -1;
        }
        resolveFullCount(a) {
            if (this.c0 != null) {
                return this.di.u + this.getRootSummaryRowCount();
            }
            return a + this.getRootSummaryRowCount();
        }
        ez() {
            let a = 0;
            let b = 0;
            let c = this.shouldEmitSectionHeaders;
            let d = this.shouldEmitSectionFooters;
            for (let e = 0; e < this.c0.length; e++) {
                let f = new SectionData();
                let g = b;
                let h = this.c0[e].endIndex - this.c0[e].startIndex;
                f.af = a;
                f.ae = e;
                f.d = new Array(this.groupDescriptions.k.count);
                for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                    f.d[i] = 0;
                }
                f.ad = a + h;
                f.t = 0;
                f.e = this.c0[e].groupKeyProperties;
                f.f = this.c0[e].groupKeyValues;
                f.h = new Array(0);
                f.ai(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
                this.es(f, e == 0);
                if (d) {
                    f.u = f.c.length;
                }
                let j = 0;
                f.i = new Array(this.groupDescriptions.k.count);
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.c0[e].summaryResults != null) {
                        f.i[this.groupDescriptions.k.count - 1] = this.c0[e].summaryResults;
                        if (f.i != null) {
                            for (let k = 0; k < f.i[this.groupDescriptions.k.count - 1].length; k++) {
                                let l = f.i[this.groupDescriptions.k.count - 1][k];
                                l.summaryIndex = this.eb(l);
                                l.groupKey = f.f;
                            }
                            j = SectionData.r(f.i[this.groupDescriptions.k.count - 1]).count;
                        }
                    }
                }
                if (this.includeSummaryRowsInSection && this.shouldEmitSummaryRows) {
                    if (this.isSectionSummaryRowsAtBottom) {
                        f.ag = j;
                    }
                    else {
                        f.ah = j;
                        g += j;
                    }
                    b += j;
                    f.ad = f.ad + j;
                }
                if (d) {
                    b++;
                }
                if (c) {
                    let m = 0;
                    f.b = new Array(f.c.length);
                    if (f.z > -1) {
                        let n = this.di.t._inner[f.z];
                        for (let o = 0; o < n.f.length; o++) {
                            m = o;
                            if (!Base.equalsStatic(n.f[o], f.f[o])) {
                                break;
                            }
                        }
                    }
                    for (let p = m; p < f.c.length; p++) {
                        b++;
                        g++;
                        f.ad = f.ad + 1;
                        let q = this.em(f, p);
                        f.a[p] = q;
                        f.b[p] = p - m;
                        if (this.dq.containsKey(q)) {
                            f.c[p] = this.dq.item(q);
                        }
                        else {
                            f.c[p] = this.isSectionExpandedDefault;
                        }
                        if (!f.c[p]) {
                            let r = 0;
                            let s = f.c.length - 1 - p;
                            f.ad = f.ad - r;
                            b -= r;
                            if (d) {
                                b--;
                                f.u = f.u - 1;
                            }
                            p += s;
                        }
                    }
                }
                f.y = c ? f.v() : 0;
                f.t = g;
                this.di.z(f, h + 1);
                if (!f.p) {
                    let t = f.w();
                    f.ad = f.ad - (f.d[t] + j);
                    b -= f.d[t] + j;
                }
                a = f.ad + 1;
                this.di.t.add(f);
                f.q = this.di.r(f);
            }
            let u = 0;
            for (let v = 0; v < this.di.t.count; v++) {
                let w = this.di.t._inner[v];
                if (this.shouldEmitSectionHeaders) {
                    if (!w.q) {
                        let x = w.ad - w.af + 1;
                        this.di.ae(w.ae);
                        this.di.ab(w, -x, -x);
                        v--;
                        u++;
                        continue;
                    }
                }
                if (w.z > -1) {
                    w.z -= u;
                }
            }
        }
        es(a, b) {
            if (b) {
                this.c2 = new Array(this.groupDescriptions.k.count);
                for (let c = 0; c < this.c2.length; c++) {
                    this.c2[c] = a;
                }
            }
            if (this.sectionHeaderDisplayMode == 1) {
                let d = false;
                let e = a.e.length;
                for (let f = 0; f < e; f++) {
                    if (d) {
                        this.c2[f] = a;
                        continue;
                    }
                    let g = false;
                    if (this.c2[f].f[f] == null) {
                        g = a.f[f] != null;
                    }
                    else {
                        g = !Base.equalsStatic(this.c2[f].f[f], a.f[f]);
                    }
                    if (g) {
                        this.c2[f] = a;
                        if (f - 1 > -1) {
                            let h = f - 1;
                            while (h >= 0 && this.c2[h].o) {
                                h = h - 1;
                            }
                            a.z = this.c2[h].ae;
                        }
                        d = true;
                    }
                }
            }
            else {
                let i = false;
                for (let j = 0; j < a.e.length; j++) {
                    if (this.c2[0].f[j] == null) {
                        if (this.c2[0].f[j] != a.f[j]) {
                            i = true;
                            break;
                        }
                        continue;
                    }
                    if (!Base.equalsStatic(this.c2[0].f[j], a.f[j])) {
                        i = true;
                        break;
                    }
                }
                if (i) {
                    this.c2[0] = a;
                }
            }
        }
        er(a) {
        }
        ey(a) {
            if (this.updateNotifier != null) {
                let b = a.pageIndex() * this.actualPageSize;
                if (this.actualDataProvider != null) {
                    if (b > this.actualDataProvider.actualCount) {
                        return;
                    }
                }
                let c = this.ec(b);
                let d = this.ec(b + a.count() - 1);
                if (c > 0 && this.getRowType(c - 1) == 1) {
                    c--;
                }
                if (this.actualCount == 0 && a.count() == 0) {
                    this.onClearItems();
                }
                else {
                    this.updateNotifier.rangeActualized(c, d);
                }
            }
        }
        ec(a) {
            if (this.aq && this.di.q) {
                let b = this.di.g(a);
                if (b == null) {
                    b = this.di.d();
                }
                if (!b.p) {
                    return b.af;
                }
                return a + b.t;
            }
            return a;
        }
        ew(a) {
            a();
        }
        get_isVirtual() {
            return true;
        }
        isPlaceholderItem(a) {
            let b = this.c5(a);
            let c = b[0];
            if (!this.dj.d(c)) {
                if (b[1] == -1) {
                    return false;
                }
                return true;
            }
            return false;
        }
        getItemAtIndex(a) {
            if (a >= this.actualCount - this.getRootSummaryRowCount()) {
                return this.eh(a);
            }
            let b = this.c5(a);
            let c = b[0];
            if (!this.dj.d(c)) {
                if (b[1] == -1) {
                    return this.eh(a);
                }
                return null;
            }
            let d = this.dj.item(c);
            let e = b[1];
            if (e == -1) {
                return this.eh(a);
            }
            return d.getItemAtIndex(e);
        }
        getItemFromKey(a) {
            let b = this.indexOfKey(a);
            if (b >= 0) {
                return this.getItemAtIndex(b);
            }
            return null;
        }
        eh(a) {
            if (a >= this.actualCount - this.getRootSummaryRowCount()) {
                let b = new DataSourceSpecialRow();
                b.rowType = 4;
                b.level = 0;
                let c = a - (this.actualCount - this.getRootSummaryRowCount());
                let d = SectionData.r(this.c4);
                let e = new Array(d._inner[c].count);
                d._inner[c].values.copyTo(e, 0);
                b.summaryResults = e;
                return b;
            }
            let f = this.dh(a);
            if (f != null) {
                let g = f.j(a);
                if (g == 1 || g == 2) {
                    let h = new DataSourceSpecialRow();
                    h.rowType = g;
                    h.summaryResults = f.i[f.i.length - 1];
                    h.level = g == 1 ? f.w() + (a - f.af) : (f.u - 1) - (f.w() + (a - (f.ad - f.u + 1)));
                    if (this.sectionHeaderDisplayMode == 0) {
                        for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                            h.setSectionValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                            h.setValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                        }
                    }
                    else {
                        if (h.level >= 0 && h.level < this.groupDescriptions.k.count) {
                            h.setSectionValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                            h.setValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                        }
                    }
                    return h;
                }
                else if (g == 5) {
                    let j = new DataSourceSpecialRow();
                    j.rowType = 5;
                    j.level = f.c.length;
                    let k = f.x(a);
                    let l = SectionData.r(f.i[f.i.length - 1]);
                    let m = new Array(l._inner[k].count);
                    l._inner[k].values.copyTo(m, 0);
                    j.summaryResults = m;
                    return j;
                }
            }
            return null;
        }
        c5(a) {
            if (this.aq && this.di.q) {
                let b = false;
                let c = this.dh(a);
                if (c == null) {
                    c = this.di.d();
                    if (this.c4.length > 0 && a > c.ad) {
                        b = true;
                    }
                }
                let d = c.af;
                if (this.shouldEmitSectionHeaders && a >= d && a < d + c.v()) {
                    b = true;
                }
                if (a - (d + c.v() - 1) <= c.aa + c.ah) {
                    b = true;
                }
                if (this.shouldEmitSectionFooters) {
                    if (a <= c.ad && a >= c.ad - c.c.length - c.ag) {
                        b = true;
                    }
                }
                else if (c.ag > 0) {
                    if (a > c.ad - c.ag && a <= c.ad) {
                        b = true;
                    }
                }
                let e = a - c.t;
                let f = truncate(Math.floor(e / this.actualPageSize));
                let g = e % this.actualPageSize;
                if (b) {
                    g = -1;
                }
                let h = new Array(2);
                h[0] = f;
                h[1] = g;
                return h;
            }
            else {
                let i = truncate(Math.floor(a / this.actualPageSize));
                let j = a % this.actualPageSize;
                let k = new Array(2);
                k[0] = i;
                k[1] = j;
                return k;
            }
        }
        dh(a) {
            return this.di.e(a);
        }
        getItemPropertyAtIndex(a, b) {
            if (a > (this.actualCount - 1) - this.getRootSummaryRowCount()) {
                return this.ei(a, b);
            }
            let c = this.c5(a);
            let d = c[0];
            if (!this.dj.d(d)) {
                if (c[1] == -1) {
                    return this.ei(a, b);
                }
                return null;
            }
            let e = this.dj.item(d);
            let f = c[1];
            if (f == -1) {
                return this.ei(a, b);
            }
            if (this.ar()) {
                let g = e.getItemAtIndex(f);
                let h = this.ao(g, b);
                if (h) {
                    let i = this.a2(g, b);
                    return i;
                }
            }
            return e.getItemValueAtIndex(f, b);
        }
        ei(a, b) {
            let c = this.eh(a);
            if (typeCast(DataSourceSpecialRow.$, c) !== null) {
                return c.getValue(b);
            }
            return null;
        }
        ex(a) {
            if (!this.ds.containsKey(a)) {
                this.ds.addItem(a, 1);
            }
            else {
                this.ds.item(a, this.ds.item(a) + 1);
            }
        }
        ev(a) {
            if (this.ds.containsKey(a)) {
                this.ds.item(a, this.ds.item(a) - 1);
                if (this.ds.item(a) <= 0) {
                    this.ds.removeItem(a);
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.removePageRequest(a);
                    }
                }
            }
        }
        addCandidate(a, b) {
            let c = false;
            if (!this.dr.containsKey(a)) {
                let d = new List$1(Number_$type, 0);
                let e = this.transformPage(a);
                for (let f = 0; f < e.length; f++) {
                    let g = e[f];
                    if (!this.dj.d(g)) {
                        d.add(g);
                        this.ex(g);
                        let h = this.ds.item(g);
                        if (h == 1 && this.actualDataProvider != null) {
                            this.actualDataProvider.addPageRequest(g, b);
                        }
                        c = true;
                    }
                }
                if (d.count > 0) {
                    this.dr.addItem(a, d.toArray());
                }
            }
            return c;
        }
        removeCandidate(a) {
            if (this.dr.containsKey(a)) {
                for (let b = 0; b < this.dr.item(a).length; b++) {
                    let c = this.dr.item(a)[b];
                    this.ev(c);
                }
                this.dr.removeItem(a);
            }
        }
        transformPage(a) {
            let b = [a];
            if (this.aq && this.di.q) {
                let c = a * this.actualPageSize;
                let d = c + this.actualPageSize - 1;
                let e = this.dh(c);
                let f = new List$1(Number_$type, 0);
                for (let g = c; g <= d; g++) {
                    if (e == null) {
                        break;
                    }
                    if (g > e.ad) {
                        if (e.ae < this.di.t.count - 1) {
                            e = this.di.t._inner[e.ae + 1];
                        }
                        else {
                            break;
                        }
                    }
                    if (!e.p || (g >= e.af && g <= e.af + (e.v() - 1) + e.aa)) {
                        continue;
                    }
                    let h = g - e.t;
                    let i = intDivide(h, this.actualPageSize);
                    if (!f.contains(i)) {
                        f.add(i);
                    }
                }
                b = f.toArray();
            }
            return b;
        }
        getUnrealizedCount() {
            let a = this.dj.g * this.actualPageSize;
            let b = this.actualCount - a;
            return b;
        }
        onSetItemOverride(a, b, c) {
            super.onSetItemOverride(a, b, c);
            let d = this.c5(a);
            let e = d[0];
            if (this.dj.d(e)) {
                this.dj.j(e);
            }
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            this.actualPageSizePopulated = false;
            let a = this.actualCount != 0;
            this.dl = true;
            if (!this.dm) {
                this.resetCache();
                if (a) {
                    this.onClearItems();
                }
                this.c0 = null;
                this.c4 = null;
                this.d9 = 0;
                this.di.v();
            }
            else {
                this.dm = false;
                if (a) {
                    this.onClearItems();
                }
            }
            this.e1();
            this.dg.au();
            this.dl = false;
        }
        e1() {
            if (this.actualDataProvider != null) {
                for (let a of fromEnum(this.dr.values)) {
                    for (let c = 0; c < a.length; c++) {
                        let b = a[c];
                        this.actualDataProvider.addPageRequest(b, 1);
                    }
                }
            }
        }
        onClearItemsOverride() {
            super.onClearItemsOverride();
            if (!this.dl) {
                this.queueAutoRefresh();
            }
        }
        onInsertItemOverride(a, b) {
            super.onInsertItemOverride(a, b);
            this.queueAutoRefresh();
        }
        onRemoveItemOverride(a, b) {
            super.onRemoveItemOverride(a, b);
            this.queueAutoRefresh();
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            let b = this.dj.b;
            let c = b.o;
            let d = b.q;
            let e = d.count;
            let f = b.p;
            for (let g = 0; g < e; g++) {
                if (f._inner[g]) {
                    continue;
                }
                let h = d._inner[g].b;
                let i = h.count();
                for (let j = 0; j < i; j++) {
                    if (this.dp(h.getItemAtIndex(j), a)) {
                        let k = typeGetValue(c._inner[g]);
                        let l = k * this.actualPageSize;
                        return l + j;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            return -1;
        }
        dp(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return -1;
            }
            this.ensureComparables(this.actualSchema);
            let c = this.df();
            if (this.aq && this.shouldEmitSectionHeaders && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                if (this.di.t.count > 0) {
                    for (let d = 0; d < this.di.t.count; d++) {
                        let e = this.di.t._inner[d];
                        let f = new DataSourceSpecialRow();
                        for (let g = 0; g < e.e.length; g++) {
                            let h = e.e[g];
                            let i = e.f[g];
                            f.setSectionValue(h, i);
                        }
                        if (c.i(f, a) == 0) {
                            return d;
                        }
                    }
                }
            }
            let j = this.dj.b;
            let k = j.o;
            let l = j.q;
            let m = l.count;
            let n = j.p;
            for (let o = 0; o < m; o++) {
                if (n._inner[o]) {
                    continue;
                }
                let p = l._inner[o].b;
                let q = p.count();
                for (let r = 0; r < q; r++) {
                    if (c.i(p.getItemAtIndex(r), a) == 0) {
                        let s = typeGetValue(k._inner[o]);
                        let t = s * this.actualPageSize;
                        return t + r;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            return -1;
        }
        df() {
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        unpinRow(a) {
            super.unpinRow(a);
        }
        pinRow(a) {
            super.pinRow(a);
        }
        isRowPinned(a) {
            return super.isRowPinned(a);
        }
        getStickyRowsInRange(a, b) {
            if ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0)) {
                return null;
            }
            let c = this.dh(a);
            let d = this.dh(b);
            if (this.di.t.count > 0) {
                if (this.di.t.count == 1) {
                    c = this.di.t._inner[0];
                    d = this.di.t._inner[0];
                }
                else {
                    c = this.di.e(a);
                    if (c != null) {
                        while (c.z != -1) {
                            c = this.di.t._inner[c.z];
                        }
                    }
                    d = this.di.e(b);
                    if (b >= this.actualCount - this.getRootSummaryRowCount()) {
                        d = this.di.d();
                    }
                }
            }
            else if (this.getRootSummaryRowCount() > 0) {
                let e = new List$1(Number_$type, 0);
                for (let f = this.actualCount - this.getRootSummaryRowCount(); f < this.actualCount; f++) {
                    e.add(f);
                }
                return e.toArray();
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.d1 && c.aa == this.d3 && c.af == this.d4 && c.ad == this.d2 && c.ah == this.d6 && c.ag == this.d5 && d.ae == this.du && d.aa == this.dw && d.af == this.dx && d.ad == this.dv && d.ah == this.dz && d.ag == this.dy && this.getRootSummaryRowCount() == this.d0) {
                return this.c1;
            }
            this.d1 = c.ae;
            this.du = d.ae;
            this.d3 = c.aa;
            this.dw = d.aa;
            this.d4 = c.af;
            this.dx = d.af;
            this.d2 = c.ad;
            this.dv = d.ad;
            this.dz = d.ah;
            this.dy = d.ag;
            this.d6 = c.ah;
            this.d5 = c.ag;
            this.d0 = this.getRootSummaryRowCount();
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.di.t._inner[h];
                let j = i.c.length;
                let k = i.v();
                if (this.shouldEmitSectionHeaders && this.aq) {
                    for (let l = 0; l < i.c.length; l++) {
                        if (i.a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                        }
                        if (!i.c[l]) {
                            break;
                        }
                    }
                }
                if (i.p) {
                    for (let n = 0; n < i.ah; n++) {
                        g.add(i.af + n + k);
                    }
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < i.aa; o++) {
                            g.add(i.af + o + j);
                        }
                    }
                    if (this.summaryScope == 0 || this.summaryScope == 2) {
                        if (this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                            for (let p = i.ag - 1; p >= 0; p--) {
                                if (this.shouldEmitSectionFooters) {
                                    g.add(i.ad - k - p);
                                }
                                else {
                                    g.add(i.ad - p);
                                }
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.aq) {
                    for (let q = i.c.length - 1; q >= 0; q--) {
                        if (!i.c[q]) {
                            break;
                        }
                        g.add(i.ad - q);
                    }
                }
            }
            for (let r = this.actualCount - this.getRootSummaryRowCount(); r < this.actualCount; r++) {
                g.add(r);
            }
            this.c1 = g.toArray();
            return this.c1;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        getIsRowExpandedAtIndex(a) {
            let b = this.di.e(a);
            if (b == null) {
                b = this.di.d();
            }
            for (let c = 0; c < b.a.length; c++) {
                if (b.a[c] != null) {
                    if (a == b.af + b.b[c]) {
                        return b.c[c];
                    }
                }
            }
            return super.getIsRowExpandedAtIndex(a);
        }
        setIsRowExpandedAtIndex(a, b) {
            let c = this.di.e(a);
            if (c == null) {
                c = this.di.d();
            }
            for (let d = 0; d < c.a.length; d++) {
                if (c.a[d] != null) {
                    if (a == c.af + c.b[d]) {
                        let e = false;
                        let f = c.a[d];
                        if (this.dq.containsKey(f) && this.dq.item(f) != b) {
                            let g = this.dq.item(f);
                            if (b == this.isSectionExpandedDefault) {
                                this.dq.removeItem(f);
                            }
                            else {
                                this.dq.item(f, b);
                            }
                            e = true;
                            this.onRowExpansionChanged(a, g, b);
                        }
                        else if (b != this.isSectionExpandedDefault) {
                            this.dq.addItem(f, b);
                            e = true;
                            this.onRowExpansionChanged(a, this.isSectionExpandedDefault, b);
                        }
                        if (e) {
                            this.di.v();
                            this.ez();
                            this.dm = true;
                            if (this.actualCount != this.di.u) {
                                this.actualCount = this.di.u + this.getRootSummaryRowCount();
                            }
                            else {
                                this.queueAutoRefresh();
                            }
                        }
                        break;
                    }
                }
            }
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.isGroupingSupported) {
                if (this.sectionHeaderDisplayMode == 1) {
                    return this.groupDescriptions.k.count;
                }
                else if (this.groupDescriptions.k.count > 0) {
                    return 1;
                }
            }
            return 0;
        }
        getRootSummaryRowCount() {
            return this.shouldEmitSummaryRows ? this.d9 : 0;
        }
        el(a) {
            let b = "";
            for (let c = 0; c < a.e.length; c++) {
                let d = a.f[c].toString();
                b += a.e[c] + ":" + d;
            }
            return b;
        }
        em(a, b) {
            if (this.sectionHeaderDisplayMode == 0) {
                return this.el(a);
            }
            let c = "";
            for (let d = 0; d < a.e.length; d++) {
                let e = a.f[d].toString();
                c += a.e[d] + ":" + e + ":";
            }
            let f = b.toString();
            c += f;
            return c;
        }
        getRootSummaryResults() {
            return this.c4;
        }
        getSectionSummaryResults(a) {
            if (this.di.t.count > 0 && a >= 0 && a < this.di.t.count) {
                return this.di.t._inner[a].i;
            }
            return null;
        }
        clone() {
            return null;
        }
        cloneProperties(a) {
            super.cloneProperties(a);
            let b = typeCast(VirtualDataSource.$, a);
            if (b != null) {
                b.pageSizeRequested = this.pageSizeRequested;
                b.maxCachedPages = this.maxCachedPages;
            }
        }
        get concurrencyTag() {
            return this._concurrencyTag;
        }
        set concurrencyTag(a) {
            this._concurrencyTag = a;
        }
        get_isBatchingEnabled() {
            return true;
        }
        set_isBatchingEnabled(a) {
            super.set_isBatchingEnabled(a);
        }
        updatePropertyAtKey(a, b, c, d = false) {
            let e = super.updatePropertyAtKey(a, b, c, d);
            if (this.concurrencyTag != null && this.ar()) {
                let f = this.indexOfKey(a);
                if (f > -1) {
                    let g = this.getItemAtIndex(f);
                    let h = this.actualDataProvider.getItemValue(g, this.concurrencyTag);
                    if (h != null) {
                        let i = this.v.g(a);
                        i.version = h;
                    }
                }
            }
            return e;
        }
        removeItemByKey(a) {
            super.removeItemByKey(a);
            if (this.concurrencyTag != null && this.ar()) {
                let b = this.indexOfKey(a);
                if (b > -1) {
                    let c = this.getItemAtIndex(b);
                    let d = this.actualDataProvider.getItemValue(c, this.concurrencyTag);
                    if (d != null) {
                        let e = this.v.g(a);
                        e.version = d;
                    }
                }
            }
        }
        ct(a, b) {
            if (a == 5) {
                let c = b;
                let d = c.a;
                let e = new List$1(TransactionState.$, 0);
                for (let f = 0; f < d.length; f++) {
                    let g = d[f].transactionType;
                    let h = null;
                    let i = null;
                    if (g == TransactionType.Delete || g == 1) {
                        let j = new Dictionary$2(String_$type, Base.$, 0);
                        let k = d[f].id;
                        for (let l = 0; l < this.actualPrimaryKey.length; l++) {
                            j.addItem(this.actualPrimaryKey[l], k[l]);
                        }
                        h = j;
                    }
                    if (g == 0) {
                        let m = new Dictionary$2(String_$type, Base.$, 0);
                        let n = d[f].id;
                        let o = n[0];
                        for (let p = 0; p < this.actualSchema.propertyNames.length; p++) {
                            let q = this.actualSchema.propertyNames[p];
                            m.addItem(q, this.actualDataProvider.getItemValue(o, q));
                        }
                        i = m;
                    }
                    else if (g == 1) {
                        i = d[f].value;
                    }
                    if (h != null) {
                        let r = {};
                        let s = h;
                        for (let t of fromEnum(s)) {
                            r[t.key] = t.value;
                        }
                        h = r;
                    }
                    if (i != null) {
                        let u = {};
                        let v = i;
                        for (let w of fromEnum(v)) {
                            u[w.key] = w.value;
                        }
                        i = u;
                    }
                    e.add(((() => {
                        let $ret = new TransactionState(h, g, i);
                        $ret.version = d[f].version;
                        return $ret;
                    })()));
                }
                let x = e.toArray();
                if (this.batchStarted != null) {
                    this.batchStarted(this, new DataSourceBatchStartedEventArgs(x));
                }
                this.actualDataProvider.createBatchRequest(x);
            }
        }
        et(a, b, c) {
            if (b) {
                this.queueAutoRefresh();
            }
            if (this.batchCompleted != null) {
                this.batchCompleted(this, new DataSourceBatchCompletedEventArgs(a, c));
            }
        }
    }
    VirtualDataSource.$t = /*@__PURE__*/ markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
    return VirtualDataSource;
})();
